from copy import copy

import numpy as np

import matplotlib.pyplot as plt
import matplotlib.animation as animation

import cfplot as cfp
import cf


# Read in field of choice and check values to subspace on
f=cf.read('cfplot_data/ggap.nc')
f1 = f[1]
pressure_vals = f1.construct("pressure").array[:5]
print("f1 PRESSURES:", pressure_vals)

# Set smaller map
cfp.mapset(-2, 2, 50, 54, resolution='110m')


# Set up figure
# TODO



cfp.gopen()
u = f1.subspace(pressure=pressure_vals[0])
cfp.con(u, blockfill=True, lines=False)
figure = cfp.plotvars.mymap.figure  # copy it!
cfp.gclose(view=False)


def animate(subspace_at):
    ###cfp.gopen()
    cfp.gopen()
    u = f1.subspace(pressure=subspace_at)
    cfp.con(u, blockfill=True, lines=False)
    ###figure.remove()
    next_fig = cfp.plotvars.mymap.figure  #  copy()
    ###figure.add_artist(next_fig)

    cfp.gclose(view=False)
    return next_fig


ims = [[animate(p),] for p in pressure_vals[1:5]]
print("IMS IS", ims)
print(dir(ims[-1][0]))

"""
ani = animation.FuncAnimation(
    figure, animate, interval=20, frames=pressure_vals[1:5])
"""


ani = animation.ArtistAnimation(
    figure, ims, interval=50, ###blit=True,
    ###repeat_delay=1000
)
ani.save("ani-attempt-cfplot.mp4")


###cfp.gclose(view=False)

plt.show()
